VERSION 5.00
Object = "{6FBA474E-43AC-11CE-9A0E-00AA0062BB4C}#1.0#0"; "SYSINFO.OCX"
Begin VB.UserControl DeskToolbar 
   ClientHeight    =   465
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   540
   InvisibleAtRuntime=   -1  'True
   Picture         =   "DeskToolbar.ctx":0000
   PropertyPages   =   "DeskToolbar.ctx":13EA
   ScaleHeight     =   465
   ScaleWidth      =   540
   Tag             =   "Nr: 0"
   ToolboxBitmap   =   "DeskToolbar.ctx":140A
   Begin VB.Timer tmrAnimater 
      Enabled         =   0   'False
      Interval        =   100
      Left            =   210
      Top             =   525
   End
   Begin VB.Timer tmrCheckisMouseOver 
      Enabled         =   0   'False
      Interval        =   200
      Left            =   630
      Top             =   525
   End
   Begin SysInfoLib.SysInfo SysInfo 
      Left            =   0
      Top             =   105
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   327680
   End
End
Attribute VB_Name = "DeskToolbar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "PropPageWizardRun" ,"Yes"
'APIs
'Types
Private Type RECT
    X1 As Long
    Y1 As Long
    X2 As Long
    Y2 As Long
End Type

Private Type POINTAPI
        X As Long
        Y As Long
End Type

'Declares
Private Declare Function SetWindowPos Lib "user32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Private Declare Function SetCursorPos Lib "user32" (ByVal X As Long, ByVal Y As Long) As Long
Private Declare Function GetWindowRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT) As Long
Private Declare Function GetClientRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT) As Long

'Consts
Private Const SWP_NOMOVE = 2 'SetWindowPos
Private Const SWP_NOSIZE = 1
Private Const HWND_TOPMOST = -1
Private Const HWND_NOTOPMOST = -2

'Enum Consts
Public Enum WhereonDeskConstants
    WDC_onTop = 1
    WDC_onBottom = 2
    WDC_onLeft = 3
    WDC_onRight = 4
End Enum

'Default Property Values:
Const m_def_PixelsSeen = 2
Const m_def_PixelsperSec = 250
Const m_def_Opened = False
Const m_def_AlwaysonTop = True
Const m_def_Where = 1
Const m_def_inForm = False
Const m_def_Animate = True
Const m_def_Enabled = True
Const m_def_Detail = 50

'Property Variables:
Dim m_PixelsSeen As Integer
Dim m_PixelsperSec As Integer
Dim m_Opened As Boolean
Dim m_AlwaysonTop As Boolean
Dim m_Where As WhereonDeskConstants
Dim m_inForm As Boolean
Dim m_ReferenceControl As Control
Dim m_Animate As Boolean
Dim m_Enabled As Boolean
Dim m_Detail As Integer

'Dims
Dim Way As Integer '0 means Horizontal 1 means Vertical
Dim DeskW As Integer
Dim DeskH As Integer
Dim PixtoGo As Integer

'Event Declarations:
Event OpenAnimateStarts()
Attribute OpenAnimateStarts.VB_Description = "Called when the opening animate is starts."
Event CloseAnimateStarts()
Attribute CloseAnimateStarts.VB_Description = "Called when the closing animate is starts."
Event OpenAnimateEnds()
Attribute OpenAnimateEnds.VB_Description = "Called when the opening animate is ended."
Event CloseAnimateEnds()
Attribute CloseAnimateEnds.VB_Description = "Called when the closing animate is ended."

Private Sub SysInfo_DisplayChanged()
    Refresh
End Sub

Private Sub tmrAnimater_Timer()
'Dims
Dim frm As Object 'Parent form or ref obj
Dim Det As Single 'Detail
Dim WR, HR
Dim PRect As RECT
Dim IRect As RECT
'Codes
If Not Me.inForm Then
    Set frm = UserControl.Parent 'on which form
    WR = 15
    HR = 15
Else
GetClientRect UserControl.Parent.hWnd, PRect
GetWindowRect UserControl.Parent.hWnd, IRect
    Set frm = Me.ReferenceControl  'Ref object
        WR = (UserControl.Parent.ScaleWidth / ((UserControl.Parent.Width - 30 * GetfO) / 15))
        HR = (UserControl.Parent.ScaleHeight / ((UserControl.Parent.Height - 30 * GetfO - 15 * GetfT) / 15))
End If
tmrCheckisMouseOver.Enabled = False
Det = Me.Detail / 1000
    If Abs(PixtoGo) <= CInt(Me.PixelsperSec * Det) Then
        Refresh
            tmrAnimater.Enabled = False
                tmrCheckisMouseOver.Enabled = True
            Exit Sub
    End If
        If Way = 0 Then
            frm.Top = frm.Top + HR * (Sgn(PixtoGo) * Me.PixelsperSec * Det)
                PixtoGo = PixtoGo - Sgn(PixtoGo) * Me.PixelsperSec * Det
        Else
            frm.Left = frm.Left + WR * (Sgn(PixtoGo) * Me.PixelsperSec * Det)
                PixtoGo = PixtoGo - Sgn(PixtoGo) * Me.PixelsperSec * Det
        End If
End Sub

Private Sub tmrCheckisMouseOver_Timer()
'Dims
Dim MousePos As POINTAPI
Dim frm As Object 'Parent form
Dim L, T, W, H, WR, HR, WL, HT, fO, fT
Dim IRect As RECT
Dim PRect As RECT

'Codes
If UserControl.Parent.WindowState = 1 Then Exit Sub
If Not UserControl.Ambient.UserMode Then Exit Sub
If Not Enabled Then Exit Sub
If Not Me.inForm Then
    Set frm = UserControl.Parent 'on which form
        L = frm.Left / 15
        T = frm.Top / 15
        W = frm.Width / 15
        H = frm.Height / 15
        WL = W + L
        HT = H + T
Else
GetClientRect UserControl.Parent.hWnd, PRect
GetWindowRect UserControl.Parent.hWnd, IRect
    Set frm = Me.ReferenceControl  'Ref object
        WR = (UserControl.Parent.ScaleWidth / ((UserControl.Parent.Width - 30 * GetfO) / 15))
        HR = (UserControl.Parent.ScaleHeight / ((UserControl.Parent.Height - 30 * GetfO - 15 * GetfT) / 15))
        L = IRect.X1 + GetfO + ReferenceControl.Left / WR
        T = IRect.Y1 + GetfO + GetfT + ReferenceControl.Top / HR
        W = ReferenceControl.Width / WR
        H = ReferenceControl.Height / HR
        WL = min(W + L, IRect.X2)
        HT = min(H + T, IRect.Y2)
        L = max(L, IRect.X1 + GetfO)
        T = max(T, IRect.Y1 + (GetfT + GetfO))
End If
'    SetCursorPos L + 1, T + 1 'a control if the counted objectpos is true if error occures delete the first remark and check
    GetCursorPos MousePos
        If MousePos.X <= WL And MousePos.X >= L And MousePos.Y <= HT And MousePos.Y >= T Then
            StartAnimate True
        Else
            StartAnimate False
        End If
End Sub

Private Sub UserControl_Resize()
'If control resizes, resize to defaults
    UserControl.Width = 540
    UserControl.Height = 465
End Sub
Public Property Get PixelsSeen() As Integer
Attribute PixelsSeen.VB_Description = "measure of seen pixels when the toolbar is closed."
    PixelsSeen = m_PixelsSeen
End Property

Public Property Let PixelsSeen(ByVal New_PixelsSeen As Integer)
    m_PixelsSeen = New_PixelsSeen
    PropertyChanged "PixelsSeen"
End Property

Public Property Get PixelsperSec() As Integer
Attribute PixelsperSec.VB_Description = "Pixels moving per second. Larger values makes toolbar open and close faster."
    PixelsperSec = m_PixelsperSec
End Property

Public Property Let PixelsperSec(ByVal New_PixelsperSec As Integer)
    m_PixelsperSec = New_PixelsperSec
    PropertyChanged "PixelsperSec"
End Property

Public Property Get Detail() As Integer
Attribute Detail.VB_Description = "Detail of movement. Smaller values are more detailed"
    Detail = m_Detail
End Property

Public Property Let Detail(ByVal New_Detail As Integer)
    m_Detail = New_Detail
    tmrAnimater.Interval = Detail
    PropertyChanged "Detail"
End Property

Public Property Get Opened() As Boolean
Attribute Opened.VB_Description = "Toolbar is opened or not."
Attribute Opened.VB_MemberFlags = "400"
    Opened = m_Opened
End Property

Public Property Let Opened(ByVal New_Opened As Boolean)
    If Ambient.UserMode = False Then Err.Raise 382
    If Ambient.UserMode Then Err.Raise 393
    m_Opened = New_Opened
    PropertyChanged "Opened"
End Property

Public Property Get AlwaysonTop() As Boolean
Attribute AlwaysonTop.VB_Description = "Determines the tool bar is on top or not."
Attribute AlwaysonTop.VB_ProcData.VB_Invoke_Property = ";Appearance"
    AlwaysonTop = m_AlwaysonTop
End Property

Public Property Let AlwaysonTop(ByVal New_AlwaysonTop As Boolean)
    m_AlwaysonTop = New_AlwaysonTop
    PropertyChanged "AlwaysonTop"
End Property

Public Property Get Where() As WhereonDeskConstants
Attribute Where.VB_Description = "Place where the toolbar is."
    Where = m_Where
End Property

Public Property Let Where(ByVal New_Where As WhereonDeskConstants)
    m_Where = New_Where
    Refresh
    PropertyChanged "Where"
End Property

Public Property Get inForm() As Boolean
Attribute inForm.VB_Description = "If a control will be a toolbar in a form set referencecontrol property to an non nothing object. Then this property will became true. Property changes automatically."
Attribute inForm.VB_MemberFlags = "400"
    inForm = m_inForm
End Property

Public Property Let inForm(ByVal New_inForm As Boolean)
    If Ambient.UserMode = False Then Err.Raise 382
    If Ambient.UserMode Then Err.Raise 393
    m_inForm = New_inForm
    PropertyChanged "inForm"
End Property

Public Property Get ReferenceControl() As Object
Attribute ReferenceControl.VB_Description = "Only avaible when inform property is true. The control in the form to be docked. If changes to non nothing object then inform property is became automatically true. If set nothing inform property sets false."
    Set ReferenceControl = m_ReferenceControl
End Property

Public Property Set ReferenceControl(ByVal New_ReferenceControl As Object)
On Error GoTo ErrH 'On error, this error is with block of object is not set error
    Set m_ReferenceControl = New_ReferenceControl
            m_inForm = False
                m_ReferenceControl.Top = m_ReferenceControl.Top
                    m_inForm = True
ErrH:
    PropertyChanged "ReferenceControl"
End Property

Public Function OpenToolbar() As Variant
Attribute OpenToolbar.VB_Description = "Opens the toolbar."
        StartAnimate True
End Function

Public Function CloseToolbar() As Variant
Attribute CloseToolbar.VB_Description = "Closes toolbar."
        StartAnimate False
End Function

Public Property Get Animate() As Boolean
Attribute Animate.VB_Description = "Determines if toolbar closes and opens animating."
Attribute Animate.VB_ProcData.VB_Invoke_Property = ";Misc"
    Animate = m_Animate
End Property

Public Property Let Animate(ByVal New_Animate As Boolean)
    m_Animate = New_Animate
    PropertyChanged "Animate"
End Property

Public Property Get Enabled() As Boolean
Attribute Enabled.VB_ProcData.VB_Invoke_Property = ";Behavior"
    Enabled = m_Enabled
End Property

Public Property Let Enabled(ByVal New_Enabled As Boolean)
    m_Enabled = New_Enabled
        If m_Enabled Then 'If enabled enable check
            Refresh
                tmrCheckisMouseOver.Enabled = True
        Else 'If not enabled disable check. This makes faster run in disable time.
            tmrCheckisMouseOver.Enabled = False
        End If
    PropertyChanged "Enabled"
End Property

Public Sub Refresh()
Attribute Refresh.VB_Description = "Refreshes the toolbar."
'Dims
Dim frm As Object 'Parent form
Dim W, H, L, T
'Codes
If Not Ambient.UserMode Then Exit Sub
    If Not m_inForm Then
            W = SysInfo.WorkAreaWidth / 15 'Desktop dimensions
            H = SysInfo.WorkAreaHeight / 15
            L = SysInfo.WorkAreaLeft / 15
            T = SysInfo.WorkAreaTop / 15
                Set frm = UserControl.Parent 'on which form
        Select Case Where
            Case 1
                    If Opened Then
                        T = -1
                            RaiseEvent OpenAnimateEnds
                    Else
                        T = Me.PixelsSeen - frm.Height / 15
                            RaiseEvent CloseAnimateEnds
                    End If
                SetWindowPos frm.hWnd, Me.AlwaysonTop, frm.Left / 15, T, frm.Width / 15, frm.Height / 15, 0 'Dividing 15 makes a twip to pixel
            Case 2
                    If Opened Then
                        T = (H - T) - frm.Height / 15
                            RaiseEvent OpenAnimateEnds
                    Else
                        T = (-Me.PixelsSeen + (H - T))
                            RaiseEvent CloseAnimateEnds
                    End If
                SetWindowPos frm.hWnd, Me.AlwaysonTop, frm.Left / 15, T, frm.Width / 15, frm.Height / 15, 0 'Dividing 15 makes a twip to pixel
            Case 3
                    If Opened Then
                        L = -1
                            RaiseEvent OpenAnimateEnds
                    Else
                        L = Me.PixelsSeen - frm.Width / 15
                            RaiseEvent CloseAnimateEnds
                    End If
                SetWindowPos frm.hWnd, Me.AlwaysonTop, L, frm.Top / 15, frm.Width / 15, frm.Height / 15, 0
            Case 4
                    If Opened Then
                        L = (W - L) - frm.Width / 15
                            RaiseEvent OpenAnimateEnds
                    Else
                        L = (-Me.PixelsSeen + (W - L) + 1)
                            RaiseEvent CloseAnimateEnds
                    End If
                SetWindowPos frm.hWnd, Me.AlwaysonTop, L, frm.Top / 15, frm.Width / 15, frm.Height / 15, 0 'Dividing 15 makes a twip to pixel
        End Select
    Else
            Set frm = Me.ReferenceControl  'on which form
        WR = (UserControl.Parent.ScaleWidth / ((UserControl.Parent.Width - 30 * GetfO) / 15))
        HR = (UserControl.Parent.ScaleHeight / ((UserControl.Parent.Height - 30 * GetfO - 15 * GetfT) / 15))
        Select Case Where
            Case 1
                    If Opened Then
                        T = -1
                            RaiseEvent OpenAnimateEnds
                    Else
                        T = Me.PixelsSeen * HR - frm.Height
                            RaiseEvent CloseAnimateEnds
                    End If
                frm.Top = T
            Case 2
                    If Opened Then
                        T = (frm.Parent.ScaleHeight) - frm.Height
                            RaiseEvent OpenAnimateEnds
                    Else
                        T = (-Me.PixelsSeen * HR + (frm.Parent.ScaleHeight))
                            RaiseEvent CloseAnimateEnds
                    End If
                frm.Top = T
            Case 3
                    If Opened Then
                        L = -1
                            RaiseEvent OpenAnimateEnds
                    Else
                        L = Me.PixelsSeen * WR - frm.Width
                            RaiseEvent CloseAnimateEnds
                    End If
                frm.Left = L
            Case 4
                    If Opened Then
                        L = (frm.Parent.ScaleWidth) - frm.Width
                            RaiseEvent OpenAnimateEnds
                    Else
                        L = (-Me.PixelsSeen * WR + (frm.Parent.ScaleWidth))
                            RaiseEvent CloseAnimateEnds
                    End If
                frm.Left = L
        End Select
    End If
End Sub

'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
    m_PixelsSeen = m_def_PixelsSeen
    m_PixelsperSec = m_def_PixelsperSec
    m_Opened = m_def_Opened
    m_AlwaysonTop = m_def_AlwaysonTop
    m_Where = m_def_Where
    m_inForm = m_def_inForm
    m_Animate = m_def_Animate
    m_Enabled = m_def_Enabled
    m_Detail = m_def_Detail
    Set m_ReferenceControl = Nothing
    tmrAnimater.Interval = m_Detail
        MsgBox "PLEASE READ HOW TO USE TEXT FOR USING. THERE IS SOME RULES OF USING THIS CONTROL."
End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    m_PixelsSeen = PropBag.ReadProperty("PixelsSeen", m_def_PixelsSeen)
    m_PixelsperSec = PropBag.ReadProperty("PixelsperSec", m_def_PixelsperSec)
    m_Opened = PropBag.ReadProperty("Opened", m_def_Opened)
    m_AlwaysonTop = PropBag.ReadProperty("AlwaysonTop", m_def_AlwaysonTop)
    m_Where = PropBag.ReadProperty("Where", m_def_Where)
    m_inForm = PropBag.ReadProperty("inForm", m_def_inForm)
    Set m_ReferenceControl = PropBag.ReadProperty("ReferenceControl", Nothing)
    m_Animate = PropBag.ReadProperty("Animate", m_def_Animate)
    m_Enabled = PropBag.ReadProperty("Enabled", m_def_Enabled)
    m_Detail = PropBag.ReadProperty("Detail", m_def_Detail)
    tmrAnimater.Interval = m_Detail
        If Ambient.UserMode Then 'If running enable check
            tmrCheckisMouseOver.Enabled = True
            Refresh
        Else 'If not running disable check. This makes a comfortable design
            tmrCheckisMouseOver.Enabled = False
        End If
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Call PropBag.WriteProperty("PixelsSeen", m_PixelsSeen, m_def_PixelsSeen)
    Call PropBag.WriteProperty("PixelsperSec", m_PixelsperSec, m_def_PixelsperSec)
    Call PropBag.WriteProperty("Opened", m_Opened, m_def_Opened)
    Call PropBag.WriteProperty("AlwaysonTop", m_AlwaysonTop, m_def_AlwaysonTop)
    Call PropBag.WriteProperty("Where", m_Where, m_def_Where)
    Call PropBag.WriteProperty("inForm", m_inForm, m_def_inForm)
    Call PropBag.WriteProperty("ReferenceControl", m_ReferenceControl, Nothing)
    Call PropBag.WriteProperty("Animate", m_Animate, m_def_Animate)
    Call PropBag.WriteProperty("Enabled", m_Enabled, m_def_Enabled)
    Call PropBag.WriteProperty("Detail", m_Detail, m_def_Detail)
End Sub

Private Function min(Val1, Val2) As Integer
min = Val1
    If Val1 > Val2 Then min = Val2
End Function

Private Function max(Val1, Val2) As Integer
max = Val2
    If Val1 > Val2 Then max = Val1
End Function

Private Function GetfO() As Integer 'a trick
'Dims
Dim IRect As RECT
Dim PRect As RECT
'Codes
    GetWindowRect UserControl.Parent.hWnd, IRect
    GetClientRect UserControl.Parent.hWnd, PRect
        GetfO = ((IRect.X2 - IRect.X1) - (PRect.X2 - PRect.X1)) / 2
End Function

Private Function GetfT() As Integer 'a trick that gets forms title height
'Dims
Dim IRect As RECT
Dim PRect As RECT
'Codes
    GetWindowRect UserControl.Parent.hWnd, IRect
    GetClientRect UserControl.Parent.hWnd, PRect
        GetfT = (IRect.Y2 - IRect.Y1) - (PRect.Y2 - PRect.Y1) - 2 * GetfO
End Function

Private Sub StartAnimate(ByVal Opening As Boolean)  'Starts animate if needed
'Dims
Dim MousePos As POINTAPI
Dim frm As Object 'Parent form
Dim W, H
Dim PRect As RECT

If Not Me.inForm Then
    Set frm = UserControl.Parent 'on which form
        W = frm.Width / 15
        H = frm.Height / 15
Else
GetClientRect UserControl.Parent.hWnd, PRect
    Set frm = Me.ReferenceControl  'Ref object
        WR = (UserControl.Parent.ScaleWidth / ((UserControl.Parent.Width - 30 * GetfO) / 15))
        HR = (UserControl.Parent.ScaleHeight / ((UserControl.Parent.Height - 30 * GetfO - 15 * GetfT) / 15))
        W = ReferenceControl.Width / WR
        H = ReferenceControl.Height / HR
End If
If Opening Then
    If Not m_Opened Then
        m_Opened = True
                If Animate Then
                        Select Case Where
                            Case 1
                                PixtoGo = H - Me.PixelsSeen
                                    Way = 0

                            Case 2
                                PixtoGo = Me.PixelsSeen - H
                                    Way = 0
                            Case 3
                                PixtoGo = W - Me.PixelsSeen
                                    Way = 1
                            Case 4
                                PixtoGo = Me.PixelsSeen - W
                                    Way = 1
                        End Select
                    tmrAnimater.Enabled = True
                    RaiseEvent OpenAnimateStarts
                End If
    End If
Else
    If m_Opened Then
        m_Opened = False
                If Animate Then
                        Select Case Where
                            Case 2
                                PixtoGo = H - Me.PixelsSeen
                                    Way = 0
                            Case 1
                                PixtoGo = Me.PixelsSeen - H
                                    Way = 0
                            Case 4
                                PixtoGo = W - Me.PixelsSeen
                                    Way = 1
                            Case 3
                                PixtoGo = Me.PixelsSeen - W
                                    Way = 1
                        End Select
                    tmrAnimater.Enabled = True
                    RaiseEvent CloseAnimateStarts
                End If
    End If
End If
    If Not Animate Then Refresh
End Sub
